# UTCTime type

class pyasn1.type.useful.UTCTime(value=NoValue(), tagSet=TagSet(), subtypeSpec=ConstraintsIntersection(), encoding='us-ascii')

  Creates UTCTime schema or value object.

  UTCTime class is based on `SimpleAsn1Type`, its objects are immutable and duck-type `bytes`. When used in octet-stream context, UTCTime type assumes “iso-8859-1” encoding.

  Keyword Arguments:

    - value (`str`, `bytes` or UTCTime object) – `str`, alternatively `bytes` representing octet-stream of serialised unicode string (note encoding parameter) or UTCTime class instance. If value is not given, schema object will be created.

    - tagSet (`TagSet`) – Object representing non-default ASN.1 tag(s)

    - subtypeSpec (`ConstraintsIntersection`) – Object representing non-default ASN.1 subtype constraint(s). Constraints verification for UTCTime type occurs automatically on object instantiation.

    - encoding (`str`) – Unicode codec ID to encode/decode `str` the payload when UTCTime object is used in octet-stream context.

  Raises:

    ValueConstraintError, PyAsn1Error – On constraint violation or bad initializer.

  Note

  The UTCTime type models a character string representing date and time.

  Formal syntax for the UTCTime value is:

  - YYMMDDhhmm[ss] standing for UTC time, two digits for the year, two for the month, two for the day and two for the hour, followed by two digits for the minutes and two for the seconds if required or

  - a string as above followed by the letter “Z” (denoting a UTC time) or

  - a string as above followed by a string (+|-)hhmm denoting time zone offset relative to UTC

  For example, 170126120000Z which stands for YYMMDDHHMMSSZ.

  clone(self, value=NoValue(), tagSet=TagSet(), subtypeSpec=ConstraintsIntersection(), encoding='us-ascii')

    Create a modified version of UTCTime schema or value object.

    The clone() method accepts the same set arguments as UTCTime class takes on instantiation except that all arguments of the clone() method are optional.

    Whatever arguments are supplied, they are used to create a copy of self taking precedence over the ones used to instantiate self.

    Note

    Due to the immutable nature of the UTCTime object, if no arguments are supplied, no new UTCTime object will be created and self will be returned instead.

  subtype(self, value=NoValue(), implicitTag=TagSet(), explicitTag=TagSet(), subtypeSpec=ConstraintsIntersection(), encoding='us-ascii')

    Create a specialization of UTCTime schema or value object.

    The subtype relationship between ASN.1 types has no correlation with subtype relationship between Python types. ASN.1 type is mainly identified by its tag(s) (`TagSet`) and value range constraints (`ConstraintsIntersection`). These ASN.1 type properties are implemented as UTCTime attributes.

    The subtype() method accepts the same set arguments as UTCTime class takes on instantiation except that all parameters of the subtype() method are optional.

    With the exception of the arguments described below, the rest of supplied arguments they are used to create a copy of self taking precedence over the ones used to instantiate self.

    The following arguments to subtype() create a ASN.1 subtype out of UTCTime type:

    Other Parameters:

      - implicitTag (`Tag`) – Implicitly apply given ASN.1 tag object to self’s `TagSet`, then use the result as new object’s ASN.1 tag(s).

      - explicitTag (`Tag`) – Explicitly apply given ASN.1 tag object to self’s `TagSet`, then use the result as new object’s ASN.1 tag(s).

      - subtypeSpec (`ConstraintsIntersection`) – Add ASN.1 constraints object to one of the self’s, then use the result as new object’s ASN.1 constraints.

    Returns:

      new instance of UTCTime schema or value object

    Note

    Due to the immutable nature of the UTCTime object, if no arguments are supplied, no new UTCTime object will be created and self will be returned instead.

  tagSet = <TagSet object, tags 0:0:23>

    Default `TagSet` object for UTCTime objects

  property isValue

    Indicate that UTCTime object represents ASN.1 value.

    If isValue is `False` then this object represents just ASN.1 schema.

    If isValue is `True` then, in addition to its ASN.1 schema features, this object can also be used like a Python built-in object (e.g. `int`, `str`, `dict` etc.).

    Returns:

      `bool` – `False` if object represents just ASN.1 schema. `True` if object represents ASN.1 schema and can be used as a normal value.

    Note

    There is an important distinction between PyASN1 schema and value objects. The PyASN1 schema objects can only participate in ASN.1 schema-related operations (e.g. defining or testing the structure of the data). Most obvious uses of ASN.1 schema is to guide serialisation codecs whilst encoding/decoding serialised ASN.1 contents.

    The PyASN1 value objects can additionally participate in many operations involving regular Python objects (e.g. arithmetic, comprehension etc).

  isSameTypeWith(other, matchTags=True, matchConstraints=True)

    Examine UTCTime type for equality with other ASN.1 type.

    ASN.1 tags (`tag`) and constraints (`constraint`) are examined when carrying out ASN.1 types comparison.

    Python class inheritance relationship is NOT considered.

    Parameters:

      other (a pyasn1 type object) – Class instance representing ASN.1 type.

    Returns:

      `bool` – `True` if other is UTCTime type, `False` otherwise.

  isSuperTypeOf(other, matchTags=True, matchConstraints=True)

    Examine UTCTime type for subtype relationship with other ASN.1 type.

    ASN.1 tags (`tag`) and constraints (`constraint`) are examined when carrying out ASN.1 types comparison.

    Python class inheritance relationship is NOT considered.

    Parameters:

      other (a pyasn1 type object) – Class instance representing ASN.1 type.

    Returns:

      `bool` – `True` if other is a subtype of UTCTime type, `False` otherwise.

  property asDateTime

    Create `datetime.datetime` object from a UTCTime object.

    Returns:

      new instance of `datetime.datetime` object

  classmethod fromDateTime(dt)

    Create UTCTime object from a `datetime.datetime` object.

    Parameters:

      dt (`datetime.datetime` object) – The datetime.datetime object to initialize the UTCTime object from

    Returns:

      new instance of UTCTime value